//				Step53.cpp
//    (firststeps.narod.ru)
//			  (1999-2001)
//			      1999 .
//           14.07.2001



#include "afxwin.h" 
#include "afxinet.h"		//      .
#include "resource.h"		//   
#include "afxdlgs.h"		//    
#include "afxcmn.h"			//    

#pragma comment(lib,"shell32.lib") //  LIB 

#define IDM_MYMENU	102		//   .

class CTestDlg : public CDialog	//   
{
 public:
   CTestDlg(CWnd* pParent=NULL);
   virtual void DoDataExchange(CDataExchange* pDX);		//    
   void SetEditStr(CString  csEdit);					//  
   CString GetEditStr();								//  
   void OnSend();										//  
   BOOL OnInitDialog();									//  
   afx_msg HBRUSH OnCtlColor( CDC* pDC, CWnd* pWnd, UINT nCtlColor );	//  
   CBrush my_color;														//  
   CSliderCtrl  csSlider;								//   
   CProgressCtrl cProgress;								//  
   CSpinButtonCtrl cSpin;								//  
   CEdit cEdit;											//
   CTreeCtrl    m_Tree;									//  
 protected:
   CString m_edit;   // 
   CString m_newedit;	//  
   DECLARE_MESSAGE_MAP();		//  
};


BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnSend)
	ON_WM_CTLCOLOR()					//  
END_MESSAGE_MAP()


HBRUSH CTestDlg::OnCtlColor( CDC* pDC, CWnd* pWnd, UINT nCtlColor )
{
	return my_color;		//   
}

BOOL CTestDlg::OnInitDialog()
{	
	CDialog::OnInitDialog();	//  
	CMenu* pSysMenu = GetSystemMenu(FALSE);		//   
	if (pSysMenu != NULL)						//    
	{
    pSysMenu->AppendMenu(MF_SEPARATOR);			//  
	pSysMenu->AppendMenu(MF_STRING, IDM_MYMENU, "MyMenu");	//   .
	}	
	my_color.CreateSolidBrush(RGB(0, 255, 155));	//  
	csSlider.SetRangeMin(0,TRUE);		// 
	csSlider.SetRangeMax(10,TRUE);	    // 
	cSpin.SetBuddy(&cEdit);				//  
	cSpin.SetRange(0,100);				// 
	cSpin.SetPos(50);					// 
	HTREEITEM  otdel=m_Tree.InsertItem("otdel");		//   
	HTREEITEM  ayp=m_Tree.InsertItem("ayp",otdel);		//   	
	HTREEITEM  work=m_Tree.InsertItem("working",otdel);	//   
	m_Tree.InsertItem("Petrov",ayp);					//  	
	m_Tree.InsertItem("Ivanow",ayp);					//  
	m_Tree.InsertItem("Katj",work);						//  
	m_Tree.InsertItem("Olj",work);						//  					
	m_Tree.InsertItem("Nastj",work);					//  
	return TRUE;
}

void CTestDlg::OnSend()
{	
 cProgress.SetRange(0,10); // 
 cProgress.SetPos(0);	   // 	
 for (int x=0;x<=10;x++)   //  
 {   
	 cProgress.SetPos(x);   //  
	 Sleep(50);				// 
 }
}



void CTestDlg::SetEditStr(CString  csEdit)
{
	m_edit=csEdit;
}

CString CTestDlg::GetEditStr()
{
	return m_edit;
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);			 //  
	DDX_Text(pDX, IDC_EDIT1, m_edit);		 //  
	DDX_Text(pDX, IDC_EDIT2, m_newedit);	 //  
	DDV_MaxChars(pDX, m_newedit, 2);		 //  
	DDX_Control(pDX, IDC_SLIDER1, csSlider); //  
	DDX_Control(pDX, IDC_PROGRESS1, cProgress); // 
	DDX_Control(pDX, IDC_SPIN1, cSpin);			//
	DDX_Control(pDX, IDC_EDIT3, cEdit);			//  
	DDX_Control(pDX, IDC_TREE1, m_Tree);		//  
}


CTestDlg::CTestDlg(CWnd* pParent)
	: CDialog(IDD_DIALOG1, pParent)
{
}

class CTestApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
};

BOOL CTestApp::InitInstance()
{
	CTestDlg dlg;						//    
	m_pMainWnd = &dlg;					//      
	dlg.SetEditStr("Hello DDX");		//  
    dlg.DoModal();
	TRACE(dlg.GetEditStr());	//       
	return FALSE;
}



CTestApp theApp;
